/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package wawi.gui.admingui.gui;

import java.awt.Color;
import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import static javax.swing.JOptionPane.showMessageDialog;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import wawi.fachlogik.adminsteuerung.grenz.LagerverkehrGrenz;
import wawi.fachlogik.adminsteuerung.steuer.LagerSteuerung;
import wawi.gui.admingui.resources.MyListModelLagerVerkegrShow;
import wawi.datenhaltung.lagerverwaltung.impl.ILagerServiceImpl;
import wawi.fachlogik.adminsteuerung.steuer.BestellungSteuerung;
import wawi.gui.admingui.resources.MyListModelBestellungen;
import static javax.swing.JOptionPane.showMessageDialog;

/**
 *
 * @author gromow
 */
public class FrameLagerVerkehrShow extends javax.swing.JFrame {
private LagerSteuerung ls;
private static int hiddenValueForLagerVerkehr;
private  int selectedRowIndex;
private Date datevon;
private Date datebis;
private List<LagerverkehrGrenz> lagerverkehrgrenzlist;
private FrameLVEinlieferungenShow framelveinlieferunenshow;
private FrameLVBestellungenShow framelvbestellungenshow;
    /**
     * Creates new form FrameLagerVerkehrShow
     */
    public FrameLagerVerkehrShow() {
        initComponents();
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();
        einlieferungenShow = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        bestellungenShow = new javax.swing.JButton();
        close = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        lblOutput = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        fieldVon = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        fieldBis = new javax.swing.JTextField();
        searchDate = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);

        ls = new LagerSteuerung();

        lagerverkehrgrenzlist = ls.lagerverkehrAnzeigen();

        MyListModelLagerVerkegrShow mymodel = new MyListModelLagerVerkegrShow();
        mymodel.setLagerverkehrgrenzlist(lagerverkehrgrenzlist);
        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null},
                {null, null, null, null}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ) {
            boolean[] canEdit = new boolean [] {
                false, false, false, false
            };

            public boolean isCellEditable(int rowIndex, int columnIndex) {
                return canEdit [columnIndex];
            }
        });
        jTable1.setModel(mymodel.buildTableModel());
        jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener(){
            public void valueChanged(ListSelectionEvent event) {
                // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event
                // print first column value from selected row

                selectedRowIndex = jTable1.getSelectedRow();
                String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();
                FrameLagerVerkehrShow.hiddenValueForLagerVerkehr = Integer.parseInt(val);
                lblOutput.setForeground(Color.BLACK);
                lblOutput.setText("Lagerverkehr : "+hiddenValueForLagerVerkehr);
            }
        });
        //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
        for (int c = 0; c < jTable1.getColumnCount(); c++)
        {
            Class<?> col_class = jTable1.getColumnClass(c);
            jTable1.setDefaultEditor(col_class, null);        // remove editor
        }
        jScrollPane1.setViewportView(jTable1);

        einlieferungenShow.setText("Einlieferungen anzeigen");
        einlieferungenShow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                einlieferungenShowActionPerformed(evt);
            }
        });

        jLabel1.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N
        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        jLabel1.setText("Lagerverkehr");

        bestellungenShow.setText("Bestellungen anzeigen");
        bestellungenShow.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                bestellungenShowActionPerformed(evt);
            }
        });

        close.setText("Schließen");
        close.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                closeActionPerformed(evt);
            }
        });

        jLabel2.setText("Ausgabe:");

        jLabel3.setText("von");

        fieldVon.setText("tt-mm-jjjj");
        fieldVon.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fieldVonActionPerformed(evt);
            }
        });

        jLabel4.setText("bis");

        fieldBis.setText("tt-mm-jjjj");

        searchDate.setText("Filtern");
        searchDate.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                searchDateActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jScrollPane1)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(einlieferungenShow)
                        .addGap(198, 198, 198)
                        .addComponent(jLabel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addGap(217, 217, 217)
                        .addComponent(bestellungenShow))
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addGap(6, 6, 6)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel3)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(fieldVon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabel4)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(fieldBis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(searchDate)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                .addComponent(close))
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(lblOutput)
                                .addGap(0, 0, Short.MAX_VALUE)))))
                .addContainerGap())
        );

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {bestellungenShow, einlieferungenShow});

        layout.linkSize(javax.swing.SwingConstants.HORIZONTAL, new java.awt.Component[] {close, searchDate});

        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(einlieferungenShow)
                    .addComponent(jLabel1)
                    .addComponent(bestellungenShow))
                .addGap(18, 18, 18)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 288, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(lblOutput))
                .addGap(23, 23, 23)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(close)
                    .addComponent(jLabel3)
                    .addComponent(fieldVon, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel4)
                    .addComponent(fieldBis, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(searchDate))
                .addGap(8, 8, 8))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void closeActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_closeActionPerformed
        // TODO add your handling code here:
        setDefaultCloseOperation(DISPOSE_ON_CLOSE);
        dispose();
    }//GEN-LAST:event_closeActionPerformed

    private void searchDateActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_searchDateActionPerformed
        // TODO add your handling code here:
        String von = fieldVon.getText();
        String bis = fieldBis.getText();
        //lagerverkehrgrenzlist=null;

        if (von.equals("") || bis.equals("") || bis.contains("m") || von.contains("m")) {
            showMessageDialog(null, "Bitte das Datum ergänzen");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");
        } else {
            jTable1 = new javax.swing.JTable();
            ls = new LagerSteuerung();
                     
            //String ins Datum umwandeln
            DateFormat formatter = new SimpleDateFormat("dd-MM-yyyy");
            try {
                datevon = formatter.parse(von);
                datebis = formatter.parse(bis);
            } catch (ParseException ex) {
                Logger.getLogger(FrameLagerVerkehrShow.class.getName()).log(Level.SEVERE, null, ex);
            }

            try {
                this.lagerverkehrgrenzlist = ls.lagerverkehrAnzeigen(datevon, datebis);
                lblOutput.setText("" + lagerverkehrgrenzlist.size());
            } catch (ParseException ex) {
                Logger.getLogger(FrameBestellungenShow.class.getName()).log(Level.SEVERE, null, ex);
            }

            MyListModelLagerVerkegrShow mymodel = new MyListModelLagerVerkegrShow();

            mymodel.setLagerverkehrgrenzlist(lagerverkehrgrenzlist);

            jTable1.setModel(mymodel.buildTableModel());

            /* Listener Event aus Google */
            jTable1.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
                public void valueChanged(ListSelectionEvent event) {
                    // http://stackoverflow.com/questions/10128064/jtable-selected-row-click-event
                    // print first column value from selected row
                    selectedRowIndex = jTable1.getSelectedRow();
                    String val = jTable1.getValueAt(jTable1.getSelectedRow(), 0).toString();
                    hiddenValueForLagerVerkehr = Integer.parseInt(val);
                    lblOutput.setText("Bestellung : " + hiddenValueForLagerVerkehr);
                }
            });

            //http://stackoverflow.com/questions/1990817/how-to-make-a-jtable-non-editable
            for (int c = 0; c < jTable1.getColumnCount(); c++) {
                Class<?> col_class = jTable1.getColumnClass(c);
                jTable1.setDefaultEditor(col_class, null);        // remove editor
            }
            jScrollPane1.setViewportView(jTable1);
            /* Listener Event aus Google */
        }
    }//GEN-LAST:event_searchDateActionPerformed

    private void einlieferungenShowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_einlieferungenShowActionPerformed
        // TODO add your handling code here:
        if (hiddenValueForLagerVerkehr == 0) {
            showMessageDialog(null, "Bitte Position auswählen");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");

        }else{
            
            FrameLVEinlieferungenShow.setLagerverkehrgrenz(lagerverkehrgrenzlist.get(selectedRowIndex));
            framelveinlieferunenshow = new FrameLVEinlieferungenShow();
            framelveinlieferunenshow.setTitle("Einlieferung anzeigen");
            framelveinlieferunenshow.setLocationRelativeTo(null);
            framelveinlieferunenshow.setVisible(true);
        }
        //framelveinlieferunenshow.setLagerverkehrgrenz();
    }//GEN-LAST:event_einlieferungenShowActionPerformed

    private void bestellungenShowActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_bestellungenShowActionPerformed
        // TODO add your handling code here:
        if (hiddenValueForLagerVerkehr == 0) {
            showMessageDialog(null, "Bitte Position auswählen");
            lblOutput.setForeground(Color.red);
            lblOutput.setText("Fehler!");

        }else{
            FrameLVBestellungenShow.setLagerverkehrgrenz(this.lagerverkehrgrenzlist.get(selectedRowIndex));
            
            framelvbestellungenshow = new FrameLVBestellungenShow();
            framelvbestellungenshow.setTitle("Bestellung anzeigen");
            framelvbestellungenshow.setLocationRelativeTo(null);
            framelvbestellungenshow.setVisible(true);
        }
    }//GEN-LAST:event_bestellungenShowActionPerformed

    private void fieldVonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fieldVonActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fieldVonActionPerformed
   
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(FrameLagerVerkehrShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(FrameLagerVerkehrShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(FrameLagerVerkehrShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(FrameLagerVerkehrShow.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new FrameLagerVerkehrShow().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton bestellungenShow;
    private javax.swing.JButton close;
    private javax.swing.JButton einlieferungenShow;
    private javax.swing.JTextField fieldBis;
    private javax.swing.JTextField fieldVon;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    private javax.swing.JLabel lblOutput;
    private javax.swing.JButton searchDate;
    // End of variables declaration//GEN-END:variables
}
